<?php

namespace STM\Competition\Playoff;

use STM\Match\MatchSelection;
use STM\Competition\CompetitionValidator;
use \Exception;
use \GetterOfTestingInstances;
use STM\StmFactory;

/**
 * Test class for Playoff.
 * Generated by PHPUnit on 2012-02-05 at 21:10:36.
 * @group competition_playoff
 */
class PlayoffTest extends \PHPUnit_Framework_TestCase {

    /** @var array(Playoff) */
    private $playoffs;

    protected function setUp() {
        $this->playoffs = GetterOfTestingInstances::find_playoffs();
    }
    
    public function testfindById() {
        foreach ($this->playoffs as $playoff) {
            parent::assertInstanceOf('\STM\Competition\Playoff\Playoff', Playoff::findById($playoff->getId()));
        }
        parent::assertFalse(Playoff::findById(null));
        parent::assertFalse(Playoff::findById(array()));
        parent::assertFalse(Playoff::findById("' OR 1 = 1 --"));
    }

    public function testCreate() {        
        PlayoffValidator::init();
        $this->assertFalse(Playoff::create(null));
        PlayoffValidator::init();
        $this->assertFalse(Playoff::create(array('playoff' => 1, 'competition' => null)));
        PlayoffValidator::init();
        CompetitionValidator::init();
        $this->assertFalse(Playoff::create(array('playoff' => array('serie_win_matches' => 2), 'competition' => null)));
        // other tests in PlayoffValidator and CompetitionValidator in checkCreate method
    }


    public function testDelete_team() {        
        foreach ($this->playoffs as $playoff) {            
            if ($playoff->getPlayedRounds() > 0) {
                // deletes only if no rounds are generated
                foreach ($playoff->getTeams() as $team) {
                    parent::assertFalse($playoff->deleteTeam($team));
                }
            } else {
                // delete if team is member of competition
                foreach (StmFactory::find()->Team->findAll() as $team) {
                    if (!$playoff->isTeamFromCompetition($team)) {
                        parent::assertFalse($playoff->deleteTeam($team));
                    }
                }
                parent::assertFalse($playoff->deleteTeam(null));
            }
        }
    }

    public function testAdd_team() {
        foreach ($this->playoffs as $playoff) {            
            if ($playoff->getPlayedRounds() > 0) {
                // add only if no rounds are generated
                parent::assertFalse($playoff->addTeam(null));
            } else {
                // add only if its not already member and instanceof Team
                foreach ($playoff->getTeams() as $team) {
                    parent::assertFalse($playoff->addTeam($team));
                }
                parent::assertFalse($playoff->addTeam(null));
            }
        }
    }
    
    public function testAdd_teams_from_competition() {
        foreach ($this->playoffs as $playoff) {            
            if ($playoff->getPlayedRounds() > 0) {
                // add only if no rounds are generated
                parent::assertFalse($playoff->addTeam(null));
            }
            // it must be different competition             
            parent::assertFalse($playoff->addTeam($playoff));
        }
    }

    public function testDelete_matches() {
        $this->assert_exception('deleteMatches', null);
    }


    public function testUpdate() {
        foreach ($this->playoffs as $playoff) {
            $current = $playoff->getSerieWinMatches();
            parent::assertFalse($playoff->update($current));
        }
        // other tests in PlayoffValidatorTest::testCheckSerieWinMatches
    }

    public function testGetSerieWinMatches() {
        $this->assert_get_to_function('is_int', 'getSerieWinMatches');
    }

    public function testGet_played_rounds() {
        $this->assert_get_to_function('is_int', 'getPlayedRounds');
    }

    public function testGet_max_round() {
        $this->assert_get_to_function('is_int', 'getMaxRound');
    }

    public function testGet_teams_with_seeded() {
        $this->assert_get_to_function('is_array', 'getTeamsWithSeeded');
    }

    public function testGet_seeded_of_team() {
        if ($this->playoffs) {
            $playoff = array_shift($this->playoffs);
            // it must be numeric
            parent::assertFalse($playoff->getSeededOfTeam(null));
            parent::assertFalse($playoff->getSeededOfTeam($playoff));
            // team must be part of playoff
            foreach (StmFactory::find()->Team->findAll() as $team) {
            $result = $playoff->getSeededOfTeam($team->getId());
                if (!$playoff->isTeamFromCompetition($team)) {
                    parent::assertFalse($result);
                } else {
                    parent::assertTrue(is_int($result) || is_null($result));
                }
            }
        }
    }

    public function testTo_array() {
        $this->assert_get_to_function('is_array', 'toArray');
    }
    
    private function assert_get_to_function($function, $method_name) {
        foreach ($this->playoffs as $playoff) {
            parent::assertTrue($function($playoff->$method_name()));
        }
    }
    
    private function assert_exception($method_name, $argument) {        
        try {            
            $playoff = array_shift($this->playoffs); 
            if (!($playoff instanceof Playoff)) {                
                return;
            }
            if (!is_null($argument)) {
                $playoff->$method_name($argument);
            } else {
                $playoff->$method_name();
            }
            parent::fail('This test did not fail as expected');
        } catch (Exception $e) {
            parent::assertEquals($e->getMessage(), 'Not Allowed');
        }
    }

}

?>
